#include "actions.hpp"
#include "json.hpp"
#include "rpc_server.hpp"
#include "vm_provider.hpp"

int main()
{
    auto state = sliger::rpc::vm_provider::VmProvider();

    auto rpc = sliger::rpc::RpcServer(
        [&](std::unique_ptr<sliger::json::Value> req,
            std::unique_ptr<sliger::rpc::BufferedWriter> writer) {
            auto action = sliger::rpc::action::action_from_json(std::move(req));
            action->perform_action(std::move(writer));
        });
    rpc.listen();
}
